import java.awt.*;
import java.awt.event.* ;
import javax.swing.*;

/**
 * @author smuelas
 *
 *
 */

class CustomScrollPane extends JPanel
{

  Drawing parent;


  static JScrollBar m_vertSB;
  static JScrollBar m_horzSB;
  static CustomViewport m_viewport;
  static Drawing m_comp;
  static int xcustom, ycustom, xcustom_old, ycustom_old;
  static JButton resiz;
  CustomScrollPane(Drawing comp)
  {
    setLayout(null);
    m_viewport = new CustomViewport();
    m_viewport.setLayout(null);
    add(m_viewport);
    m_comp = comp;
    m_viewport.add(m_comp);
    
    m_vertSB = new JScrollBar(JScrollBar.VERTICAL, 0, 0, 0, 0);
    m_vertSB.setUnitIncrement(5);
    add(m_vertSB);
    
    m_horzSB = new JScrollBar(JScrollBar.HORIZONTAL, 0, 0, 0, 0);
    m_horzSB.setUnitIncrement(5);
    add(m_horzSB);

   AdjustmentListener lst = new AdjustmentListener()
      {
	public void adjustmentValueChanged(AdjustmentEvent e)
	{
	  m_viewport.doLayout();
	}
      };
    m_vertSB.addAdjustmentListener(lst);
    m_horzSB.addAdjustmentListener(lst);
  }
  
  public void doLayout()
  {
    Dimension d = getSize();
    Dimension d0 = new Dimension(848*Drawing.u,1200*Drawing.u);
    Dimension d1 = m_vertSB.getPreferredSize();
    Dimension d2 = m_horzSB.getPreferredSize();
    
    int w = Math.max(d.width - d1.width+1, 0);
    int h = Math.max(d.height - d2.height+1, 0);
    
    m_viewport.setBounds(0, 0, w, h);
    m_vertSB.setBounds(w+1, 0, d1.width, h);
    m_horzSB.setBounds(0, h+1, w, d2.height);
    
    int xs = Math.max(d0.width -w, 0);
    m_horzSB.setMaximum(xs*6/5);
    m_horzSB.setBlockIncrement(xs/5);
    m_horzSB.setEnabled(xs > 0);
    
    int ys = Math.max(d0.height -h, 0);
    m_vertSB.setMaximum(ys*6/5);
    m_vertSB.setBlockIncrement(ys/5);
    m_vertSB.setEnabled(ys > 0);
    
    m_horzSB.setVisibleAmount(m_horzSB.getBlockIncrement());
    m_vertSB.setVisibleAmount(m_vertSB.getBlockIncrement());
  }
  

  public Dimension getPreferredSize()
  {
    Dimension d0 = new Dimension(848*Drawing.u,1200*Drawing.u);
    Dimension d1 = m_vertSB.getPreferredSize();
    Dimension d2 = m_horzSB.getPreferredSize();
    Dimension d = new Dimension(d0.width+d1.width,d0.height+d2.height);
    return d;
  }

  class CustomViewport extends JPanel
  {
    public void doLayout()
    {
      Dimension d0 = new Dimension(848*Drawing.u,1200*Drawing.u);
      xcustom_old=xcustom; ycustom_old=ycustom;
      xcustom = m_horzSB.getValue();
      ycustom = m_vertSB.getValue();
      m_comp.setBounds(-xcustom, -ycustom, d0.width+xcustom, d0.height+ycustom);
  }
}
}


