/*
 * Helpeditor.java
 *
 * Created on April 22, 2004, 12:21 PM
 */

/**
 *
 * @author  smuelas
 */

import java.util.*;
import java.lang.String.*;
import java.io.*;
import java.net.URL;
import java.io.IOException;
import java.awt.*;
import java.awt.Color.*;
import java.awt.event.*;
import java.awt.datatransfer.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.text.*;
import javax.swing.border.*;
import javax.swing.JEditorPane;
import javax.swing.JScrollPane;
import javax.swing.JSplitPane;
import javax.swing.JFrame;
import javax.swing.JTree;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.event.TreeSelectionListener;
import javax.swing.event.TreeSelectionEvent;
import javax.swing.tree.TreeSelectionModel;

public class Helpeditor extends javax.swing.JFrame {
    private boolean playWithLineStyle = false;
    private String lineStyle = "Angled"; 
    public static String welcome="file:./bienvenida.html";
    BookInfo[] contador = new BookInfo[10];
    DefaultMutableTreeNode category;
    DefaultMutableTreeNode category2;
    DefaultMutableTreeNode category3;
    Color micolor = new Color(80,80,120);

    Font mifont = new Font("Sanserif",Font.PLAIN, 10);
    Font mibold = new Font("Sanserif",Font.BOLD, 10);
    Font miboldbig = new Font("Sanserif",Font.BOLD, 14);
    
    public Helpeditor() {
    UIManager.put("Tree.leafIcon", new ImageIcon("world.png"));
    UIManager.put("Tree.openIcon", new ImageIcon("door_open.png"));
    UIManager.put("Tree.closedIcon", new ImageIcon("door_closed.png"));
    UIManager.put("Tree.expandedIcon", new ImageIcon("unlocked.png"));
    UIManager.put("Tree.collapsedIcon", new ImageIcon("locked.png"));
    initComponents();
    }
    
    private void initComponents() {
        DefaultMutableTreeNode top = new DefaultMutableTreeNode("Temas incluídos");
        createNodes(top);
        jSplitPane1 = new javax.swing.JSplitPane();
        visor = new javax.swing.JEditorPane();
        jPanel1 = new javax.swing.JPanel();
        tree = new javax.swing.JTree(top);
        tree.setBorder(new javax.swing.border.SoftBevelBorder(javax.swing.border.BevelBorder.LOWERED));
        tree.setForeground(micolor);
	tree.setFont(mibold);
        tree.getSelectionModel().setSelectionMode
	    (TreeSelectionModel.SINGLE_TREE_SELECTION);
	
        //Listen for when the selection changes.
        tree.addTreeSelectionListener(new TreeSelectionListener() {
		public void valueChanged(TreeSelectionEvent e) {
		    DefaultMutableTreeNode node = (DefaultMutableTreeNode)
			tree.getLastSelectedPathComponent();
	       		    if(node == null) return;
		    Object nodeInfo = node.getUserObject();
		    if (node.isLeaf()) {
			BookInfo item = (BookInfo)nodeInfo;
			displayURL(item.bookURL);
			for(int i=1; i<10; i++) contador[i-1] = contador[i];
			contador[9]=item;
		    }
		}
	    });
	
        if (playWithLineStyle) {
            tree.putClientProperty("JTree.lineStyle", lineStyle);
        }
	
	jPanel1.setLayout(new BorderLayout(2,2));
        jTabbedPane1 = new javax.swing.JTabbedPane();
	jTabbedPane1.setForeground(micolor);
        jScrollPane1 = new javax.swing.JScrollPane();
        jScrollPane0 = new javax.swing.JScrollPane();
	try {
	    visor = new JEditorPane(welcome);
	}
	catch (IOException ex) {
	    ex.printStackTrace(System.err);
	    System.exit(1);
	}
	visor.setEditable(false);
       	visor.addHyperlinkListener(new HyperlinkListener() {
		public void hyperlinkUpdate(HyperlinkEvent evu) {
		    try {
			if (evu.getEventType() == HyperlinkEvent.EventType.ACTIVATED)
			    visor.setPage(evu.getURL());
		    } 
		    catch (IOException ex) { ex.printStackTrace(System.err); }
		}
	    });
        jScrollPane2 = new javax.swing.JScrollPane();
        jTextArea3 = new javax.swing.JTextArea();
        jScrollPane3 = new javax.swing.JScrollPane();
        jTextArea4 = new javax.swing.JTextArea();
        jMenuBar2 = new javax.swing.JMenuBar();
        jMenu2 = new javax.swing.JMenu();
        addWindowListener(new java.awt.event.WindowAdapter() {
		public void windowClosing(java.awt.event.WindowEvent evt) {
		    exitForm(evt);
		}
	    });
	
        jSplitPane1.setDividerLocation(250);
        jSplitPane1.setOneTouchExpandable(true);
        jSplitPane1.setMinimumSize(new java.awt.Dimension(930, 760));
        jSplitPane1.setPreferredSize(new java.awt.Dimension(932, 762));
        visor.setPreferredSize(new java.awt.Dimension(680, 760));
        jSplitPane1.setRightComponent(jScrollPane0);
        jPanel1.setPreferredSize(new java.awt.Dimension(250, 760));
        jTabbedPane1.setName("");
        jTabbedPane1.setPreferredSize(new java.awt.Dimension(250, 760));
	jScrollPane1.setViewportView(tree);
        jScrollPane0.setViewportView(visor);
        jTabbedPane1.addTab("Temas", jScrollPane1);
        jScrollPane2.setViewportView(jTextArea3);
        jTabbedPane1.addTab("Tutor", jScrollPane2);
        jScrollPane3.setViewportView(jTextArea4);
        jTabbedPane1.addTab("Buscar", jScrollPane3);
        jTabbedPane1.setSelectedIndex(0);
        jPanel1.add(jTabbedPane1);
        jSplitPane1.setLeftComponent(jPanel1);
        getContentPane().add(jSplitPane1, java.awt.BorderLayout.CENTER);
        jMenu2.setText("Menu");
        jMenuBar2.add(jMenu2);
        setJMenuBar(jMenuBar2);
        pack();
        initHelp();
    }
    
    private void exitForm(java.awt.event.WindowEvent evt) {
        System.exit(1);
    }
    
    private class BookInfo {
        public String bookName;
        public URL bookURL;
        public String prefix = "file:" 
	    + System.getProperty("user.dir")
	    + System.getProperty("file.separator");
        public BookInfo(String item, String filename) {
            bookName = item;
            try {
                bookURL = new URL(prefix + filename);
            } catch (java.net.MalformedURLException exc) {
                System.err.println("Intento de crear un BookInfo "
                                   + "con un URL erróneo: " + bookURL);
                bookURL = null;
            }
        }
	
        public String toString() {
            return bookName;
        }
    }
    
    private void initHelp() {
        String s = null;
        try {
            s = "file:" 
                + System.getProperty("user.dir")
                + System.getProperty("file.separator")
                + "bienvenida.html";
        } catch (Exception e) {
            System.err.println("No se ha podido lanzar el URL: " + s);
        }
    }
    
    private void displayURL(URL url) {
        try {
            visor.setPage(url);
        } 
	catch (IOException e) {
            System.err.println("Intento de leer un URL erróneo: " + url);
        }
    }
    
    private void createNodes(DefaultMutableTreeNode top) {
	category = new DefaultMutableTreeNode("Dibujo convencional");
	category2 = new DefaultMutableTreeNode("Dibujo variacional");
	category3 = new DefaultMutableTreeNode("Metagraf básico");
        DefaultMutableTreeNode primero = null;
        DefaultMutableTreeNode primero_2 = null;
        DefaultMutableTreeNode segundo = null;
        DefaultMutableTreeNode segundo_2 = null;
        DefaultMutableTreeNode tercero = null;
        DefaultMutableTreeNode item = null;

	primero = new DefaultMutableTreeNode("Introducción");
        item = new DefaultMutableTreeNode(new BookInfo
					  ("Monitor recomendado","general_0.html"));
        primero.add(item);
        item = new DefaultMutableTreeNode(new BookInfo
					  ("Los Paneles","general_1.html"));
        primero.add(item);
        item = new DefaultMutableTreeNode(new BookInfo
					  ("Uso del Ratón","general_2.html"));
        primero.add(item);
        item = new DefaultMutableTreeNode(new BookInfo
					  ("La Malla de fondo","general_3.html"));
        primero.add(item);
        item = new DefaultMutableTreeNode(new BookInfo
					  ("La tecla Ctrl","general_4.html"));
        primero.add(item);
        item = new DefaultMutableTreeNode(new BookInfo
					  ("La Pantalla","general_5.html"));
        primero.add(item);
        item = new DefaultMutableTreeNode(new BookInfo
					  ("El Editor","general_6.html"));
        primero.add(item);
        item = new DefaultMutableTreeNode(new BookInfo
					  ("El Estado","general_7.html"));
        primero.add(item);
        item = new DefaultMutableTreeNode(new BookInfo
					  ("Agrupamiento","general_8.html"));
        primero.add(item);
        item = new DefaultMutableTreeNode(new BookInfo
					  ("Selección","general_9.html"));
        primero.add(item);
	primero_2 = new DefaultMutableTreeNode("Objetos");
        item = new DefaultMutableTreeNode(new BookInfo
					  ("Generación directa","objetos_1.html"));
        primero_2.add(item);
        item = new DefaultMutableTreeNode(new BookInfo
					  ("Generación rápida","objetos_2.html"));
        primero_2.add(item);
        item = new DefaultMutableTreeNode(new BookInfo
					  ("Traslaciones","objetos_3.html"));
        primero_2.add(item);
        item = new DefaultMutableTreeNode(new BookInfo
					  ("Rotaciones","objetos_4.html"));
        primero_2.add(item);
        item = new DefaultMutableTreeNode(new BookInfo
					  ("Escalado","objetos_5.html"));
        primero_2.add(item);
        item = new DefaultMutableTreeNode(new BookInfo
					  ("Color","objetos_6.html"));
        primero_2.add(item);
        item = new DefaultMutableTreeNode(new BookInfo
					  ("Trazo","objetos_7.html"));
        primero_2.add(item);

        segundo = new DefaultMutableTreeNode("Objetos simples");
        item = new DefaultMutableTreeNode(new BookInfo
					  ("Rectas y puntos","bienvenida.html"));
        segundo.add(item);
	item = new DefaultMutableTreeNode(new BookInfo
					  ("Rectángulos", "bienvenida.html"));
        segundo.add(item);
	item = new DefaultMutableTreeNode(new BookInfo
					  ("Círculos y Elipses","bienvenida.html"));
        segundo.add(item);
	item = new DefaultMutableTreeNode(new BookInfo
					  ("Ángulos","bienvenida.html"));
        segundo.add(item);
	item = new DefaultMutableTreeNode(new BookInfo
					  ("Curvas de Bezier","bienvenida.html"));
        segundo.add(item);
	
	
        segundo_2 = new DefaultMutableTreeNode("Texto");
	item = new DefaultMutableTreeNode(new BookInfo
					  ("Posicionar el texto","bienvenida.html"));
        segundo_2.add(item);
	item = new DefaultMutableTreeNode(new BookInfo
					  ("Escalar el texto","bienvenida.html"));
        segundo_2.add(item);
	item = new DefaultMutableTreeNode(new BookInfo
					  ("Dar color","bienvenida.html"));
        segundo_2.add(item);
	item = new DefaultMutableTreeNode(new BookInfo
					  ("Texto de LaTeX","bienvenida.html"));
        segundo_2.add(item);
	item = new DefaultMutableTreeNode(new BookInfo
					  ("Texto matemático","bienvenida.html"));
        segundo_2.add(item);
	item = new DefaultMutableTreeNode(new BookInfo
					  ("Texto PostScript","bienvenida.html"));
        segundo_2.add(item);
	item = new DefaultMutableTreeNode(new BookInfo
					  ("Texto Curvo","bienvenida.html"));
        segundo_2.add(item);
	

	tercero = new DefaultMutableTreeNode("Puntos");
	item = new DefaultMutableTreeNode(new BookInfo
					  ("Intersección de 2 rectas","bienvenida.html"));
        tercero.add(item);
	item = new DefaultMutableTreeNode(new BookInfo
					  ("Extremos de un segmento","bienvenida.html"));
        tercero.add(item);
	item = new DefaultMutableTreeNode(new BookInfo
					  ("Punto medio de un segmento","bienvenida.html"));
        tercero.add(item);
        item = new DefaultMutableTreeNode(new BookInfo
					  ("Centro de un círculo","bienvenida.html"));
        tercero.add(item);
        item = new DefaultMutableTreeNode(new BookInfo
					  ("Centro de una elipse","bienvenida.html"));
        tercero.add(item);
	item = new DefaultMutableTreeNode(new BookInfo
					  ("Intersección recta y círculo","bienvenida.html"));
        tercero.add(item);
	item = new DefaultMutableTreeNode(new BookInfo
					  ("Intersección recta y elipse","bienvenida.html"));
        tercero.add(item);

        category.add(segundo);
        category.add(segundo_2);
        category2.add(tercero);
        category3.add(primero);
	category3.add(primero_2);
	category3.add(category);
	category3.add(category2);

	item = new DefaultMutableTreeNode(new BookInfo
					  ("Bienvenida","bienvenida.html"));
	top.add(item);
	top.add(category3);

    }
    
    
    public static void main(String args[]) {
        new Helpeditor().show();
	}
    
    private javax.swing.JMenu jMenu2;
    private javax.swing.JMenuBar jMenuBar2;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JScrollPane jScrollPane0;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JScrollPane jScrollPane3;
    private javax.swing.JSplitPane jSplitPane1;
    private javax.swing.JTabbedPane jTabbedPane1;
    private javax.swing.JEditorPane visor;
    private javax.swing.JTextArea jTextArea3;
    private javax.swing.JTextArea jTextArea4;
    private javax.swing.JTree tree;
}
