import java.io.* ;
import java.awt.*;
import java.awt.geom.* ;

//********************************************************************

class Objetos_nurbs extends Objetos

//********************************************************************
{
    static final long serialVersionUID = -2156455794333762561L;
    Color c;
    boolean first=true;
    float  aw=1f, bw=1f, cw=1f, dw=1f;
    double alfa, alfa_old, xxc, yyc, longit=1, longit_old=1;
    int n, m=100;
    boolean cierra=false;
    Objetos_punto p1,p2,p3,p4;
    Objetos_nurbs(int xx0,int yy0,Objetos_list p)
    {
	super(p);
	xg[0] = xg[1] = xmin = xmax = xx0;
	yg[0] = yg[1] = ymin = ymax = yy0;
	n = 2;
	select = 3;
    }

    Objetos_nurbs(float xxg[],float yyg[],int np,Objetos_list p)
    {
	super(p);
	int i; 
        for (i=0;i<np;i++) {
	     xd[i] =(double)(xxg[i]/0.708) ;
	     yd[i] =(double)(yyg[i]/0.708) ;
	     if (xmin > xd[i]) xmin  = (int)(xd[i]-.5) ;
	     if (xmax < xd[i]) xmax  = (int)(xd[i]+.5) ;
	     if (ymin > yd[i]) ymin  = (int)(yd[i]-.5) ;
	     if (ymax < yd[i]) ymax  = (int)(yd[i]+.5) ;
	     }
	int yccc=ymax+ymin;
        for (i=0;i<np;i++) yd[i]=(double)yccc-yd[i];
	n = np;
	ijk=1;
	select = 3;
    }

    Objetos_nurbs(double xxg[],double yyg[],int np,Objetos_list p)
    {
	super(p);
	int i; 
        for (i=0;i<np;i++) {
	     xd[i] =xxg[i] ;
	     yd[i] =yyg[i] ;
	     if (xmin > xd[i]) xmin  = (int)(xd[i]-.5) ;
	     if (xmax < xd[i]) xmax  = (int)(xd[i]+.5) ;
	     if (ymin > yd[i]) ymin  = (int)(yd[i]-.5) ;
	     if (ymax < yd[i]) ymax  = (int)(yd[i]+.5) ;
	     }
	n = np;
	ijk=1;
	select = 3;
    }

    Objetos_nurbs(Objetos_punto o1, Objetos_punto o2, Objetos_punto o3, Objetos_punto o4, Objetos_list p)
    {
	super(p);
	p1=o1;p2=o2;p3=o3;p4=o4;
	ijk=1;
	select=3;
    }


  public void mueveobjeto(double xxg[], double yyg[])
  {
        for (int i=0;i<n;i++) {
	     xd[i] =xxg[i] ;
	     yd[i] =yyg[i] ;}
  }


    public void transform(double xc, double yc, double zc)
    {
	ijk=1;
	modi(xc,yc,zc,n);
    }

    public void paint(Graphics g) 
    {
	Graphics2D g2 = (Graphics2D)g ;
	GeneralPath nurb;
	String s="";
	double xA, yA, xB, yB, xC, yC, xD, yD, a0, a1, a2, a3, b0, b1, b2, b3, X, Y, ap, bp, cp, dp, k;
	c=cc;
	if(select!=0){
	s=Drawing.src36.getText();
	if(s.length() > 0)dw=Float.parseFloat(s);
	s=Drawing.src37.getText();
	if(s.length() > 0)bw=Float.parseFloat(s);
	s=Drawing.src40.getText();
	if(s.length() > 0)cw=Float.parseFloat(s);
	s=Drawing.src41.getText();
	if(s.length() > 0)aw=Float.parseFloat(s);
	}
	g.setColor(new Color(230,230,230));
	if(select!=0)g2.drawString("   "+thickness,843,270);
	float strokeThickness = thickness;
	BasicStroke stroke = new BasicStroke(strokeThickness);
	g2.setStroke(stroke);
	g.setColor(c);

	Polygon p = new Polygon();
	for(int i=0;i<n;i++) p.addPoint(xg[i],yg[i]);
	if(ijk==0)for(int i=0;i<n;i++){xd[i]=(double)xg[i];yd[i]=(double)yg[i];}
	for(int i=0;i<n;i++){ xg[i]=(int)xd[i];yg[i]=(int)yd[i]; }
	setminmax();
	xxc=0;yyc=0;
	for(int ii=0; ii<n; ii++){xxc+=xd[ii];yyc+=yd[ii];}
	xc=xxc/n; yc=yyc/n;
	if(ijk==0){xd[n]=xc+40;yd[n]=yc;xd[n+1]=xc ;yd[n+1]=yc-40;}
	
	nurb = new GeneralPath();
	for(int i=1; i<n-2; i++) {
	    first=true;
	    xA=xd[i-1]*aw; xB=xd[i]*bw; xC=xd[i+1]*cw; xD=xd[i+2]*dw;
	    yA=yd[i-1]*aw; yB=yd[i]*bw; yC=yd[i+1]*cw; yD=yd[i+2]*dw;
	    ap=aw-3*bw+3*cw-dw;
	    bp=3*bw-6*cw+3*dw;
	    cp=3*cw-3*dw;
	    dp=dw;
	    a3=xA-3*(xB-xC)-xD;
	    a2=3*xB-6*xC+3*xD;
	    a1=3*xC-3*xD;
	    a0=xD;
	    b3=yA-3*(yB-yC)-yD;
	    b2=3*yB-6*yC+3*yD;
	    b1=3*yC-3*yD;
	    b0=yD;

	    for(int j=0; j<=m; j++) {
		float t=(float)j/(float)m;
		k=((ap*t+bp)*t+cp)*t+dp;
		X = (((a3*t+a2)*t+a1)*t+a0)/k;
		Y = (((b3*t+b2)*t+b1)*t+b0)/k;
		if(n>3){
		    if(first){
			nurb.moveTo((float)X,(float)Y);
			first=false;
		    }
		    else nurb.lineTo((float)X,(float)Y);
		} 
	    }
	}

        forma[4] = (Shape) nurb;
	GeneralPath lin = new GeneralPath();
	lin.moveTo((float)xc,(float)yc);
	lin.lineTo((float)xd[n],(float)yd[n]);
	GeneralPath lin2 = new GeneralPath();
	lin2.moveTo((float)xc,(float)yc);
	lin2.lineTo((float)xd[n+1],(float)yd[n+1]);
	Shape cont = (Shape)lin;
	Shape cont2 = (Shape)lin2;
	g2.setColor(cl) ;
	
	if(select!=0) 
	    {
		stroke = new BasicStroke(0.5f);
		g2.setStroke(stroke);
		for(int i = 0;i<n;i++)
		{
		    g.setColor(Color.red);
		    if(i<n-1)g2.drawLine(xg[i],yg[i],xg[(i+1)],yg[(i+1)]);
		    g.fillRect(xg[i]-1,yg[i]-1,3,3);
		    if(n>3)g2.draw(forma[4]);
		}
		if(n>3 && Drawing.ggll==1){
		    g2.setColor(Color.blue);
		    g2.draw(cont);
		    g2.draw(cont2);
		    g2.fillRect((int)xd[n]-1,(int)yd[n]-1,3,3);
		    g2.fillRect((int)xd[n+1]-1,(int)yd[n+1]-1,3,3);
		    g2.drawOval((int)xd[n]-3,(int)yd[n]-3,7,7);
		    g2.drawLine((int)xd[n+1]-4,(int)yd[n+1],(int)xd[n+1]+4,(int)yd[n+1]);
		    g2.drawLine((int)xd[n+1],(int)yd[n+1]-4,(int)xd[n+1],(int)yd[n+1]+4);
		    g2.fillRect((int)xc-1,(int)yc-1,3,3);
		    if(Math.abs(alfa) > 0.0001)Drawing.src32.setText("a1="+(float)((int)(alfa*1800/pi))/10);
		    if(Math.abs(longit) > 0.0001)Drawing.src33.setText("es="+(float)((int)(longit*100))/100);
		}
	    }

		if(select==0)
		    {
			stroke = new BasicStroke(thickness);
			if(linea!=0)stroke = new BasicStroke(strokeThickness,BasicStroke.CAP_BUTT,BasicStroke.JOIN_MITER,10.0f,dash,0.0f);
			g2.setStroke(stroke);
			g2.draw(forma[4]);
			g2.setColor(cl) ;
		    }
		
		g2.setColor(cl);
		stroke = new BasicStroke(0.5f);
		g2.setStroke(stroke);
		
		rc=new Rectangle(xsel-5*Drawing.u,ysel-5*Drawing.u,11*Drawing.u,11*Drawing.u);
		if(g2.hit(rc,forma[4],true)) inters=true;
		else inters=false;
		
    }

public void metapost(BufferedWriter out) 
    {
	float xA, yA, xB, yB, xC, yC, xD, yD, a0, a1, a2, a3, b0, b1, b2, b3, X, Y, ap, bp, cp, dp, k; 
	float cr=0f, cv=0f, ca=0f, rc=0f, vc=0f, ac=0f;

	rc = (float) cl.getRed()/255f;
	vc = (float) cl.getGreen()/255f;
	ac = (float) cl.getBlue()/255f;

	try 
	    {
		if((int)(10f*rc)!=0 || (int)(10f*vc)!=0 || (int)(10f*ac)!=0) out.write ("loc:=("+rc+","+vc+","+ac+");\n");
		out.write("pickup pencircle scaled "+thickness+";\npath a;\nnumeric i;\n");
		for(int i=0; i<n; i++){
		out.write("xd["+i+"]:="+(xd[i]/(10*uesc))+";yd["+i+"]:="+((118*Drawing.u)-(yd[i]/(10*uesc)))+";\n");
		}
		out.write("m:="+m+"; aw:="+aw+"; bw:="+bw+"; cw:="+cw+"; dw:="+dw+";\n");
		out.write("for i=1 step 1 until "+(n-3)+":\n"); 
		out.write("first:=1;\n");
		out.write("xA:=xd[i-1]*aw; xB:=xd[i]*bw; xC:=xd[i+1]*cw; xD:=xd[i+2]*dw;\n");
		out.write("yA:=yd[i-1]*aw; yB:=yd[i]*bw; yC:=yd[i+1]*cw; yD:=yd[i+2]*dw;\n");
		out.write("ap:=aw-3*bw+3*cw-dw;\n");
		out.write("bp:=3*bw-6*cw+3*dw;\n");
		out.write("cp:=3*(cw-dw);\n");
		out.write("dp:=dw;\n");
		out.write("a3:=xA-3*(xB-xC)-xD;\n");
		out.write("b3:=yA-3*(yB-yC)-yD;\n");
		out.write("a2:=3*(xB-2*xC+xD);\nb2:=3*(yB-2*yC+yD);\n");
		out.write("a1:=3*(xC-xD);\nb1:=3*(yC-yD);\n");
		out.write("a0:=xD;\nb0:=yD;\n");
		out.write("for j=0 step 1 until m:\n"); 
		out.write("t:=j/m;\n");
		out.write("k:=((ap*t+bp)*t+cp)*t+dp;\n");
		out.write("X := (((a3*t+a2)*t+a1)*t+a0)/k;\n");
		out.write("Y := (((b3*t+b2)*t+b1)*t+b0)/k;\n");
		out.write("if first=1:\n");
		out.write("a:=(X*u,Y*u);\n");
		out.write("first:=0;\n");
		out.write("else: a:=a--(X*u,Y*u);\n");
		out.write("fi\n");
		out.write("endfor\n");
		if((int)(10f*rc)!=0 || (int)(10f*vc)!=0 || (int)(10f*ac)!=0)
		    out.write(drw+" a withcolor loc");
		else out.write(drw+" a");
		if(linea!=0)out.write(tipo_linea);
		else out.write(";\n");
		out.write("endfor\n");
	    }
	catch (IOException ex) { }            
    }
    
    public void setminmax()
    {
	xmin = 100000;
	ymin = 100000;
	xmax = -100000;
	ymax = -100000;
	zmax = -100000;
	zmin = 100000;

	    for(int i=0;i<n+2;i++)
		{
		    if(xd[i]<(double)xmin) xmin = (int)(xd[i]-5)  ;
		    if(yd[i]<(double)ymin) ymin = (int)(yd[i]-5)  ;
		    if(xd[i]>(double)xmax) xmax = (int)(xd[i]+5)  ;
		    if(yd[i]>(double)ymax) ymax = (int)(yd[i]+5)  ;
		    if(zd[i]<(double)zmin) zmin = (int)(zd[i]-5)  ;
		    if(zd[i]>(double)zmax) zmax = (int)(zd[i]+5)  ;
		}
    }

    public void moveobj(int xx,int yy)
    {
	for(int i=0;i<n+2;i++)
	    {
		if(ijk==0)
		    {
			xg[i] += xx;
			yg[i] += yy;
		    }
		if(ijk==1)
		    {
			xd[i] += (double)xx;
			yd[i] += (double)yy;
		    }
	    }
	setminmax();
    }

    public void movepoint(int xx,int yy)
    {
	if(select>1)
	    {
		if(ijk==0)
		    {
			xg[select-2] += xx;
			yg[select-2] += yy;
			if(select==n+2 || select==n+3)ijk=1;
		    }
		if(ijk==1)
		    {
			if(select!=n+3)xd[select-2] += (double)xx;
			yd[select-2] += (double)yy;
			if(select==n+2){girar();setminmax();}
			if(select==n+3){ampliar();setminmax();}
		    }
	    }
	if(select==1 && ijk==0)
	    for(int i=0;i<n;i++) {xg[i] += xx; yg[i] += yy;}
	if(select==1 && ijk==1)
	    for(int i=0;i<n;i++) {xd[i] += (double)xx; yd[i] += (double)yy;}
	setminmax();
    }

    public boolean selectpoint(int xx,int yy)
    {
	for(int i=0;i<n+2;i++)
	    {
		if(xx-(int)xd[i]<5*Drawing.u && xx-(int)xd[i]>-5*Drawing.u && yy-(int)yd[i]<5*Drawing.u && yy-(int)yd[i]>-5*Drawing.u)
		    {
			select = i+2;
			return(true);
		    }
	    }
	return(false);
    }

    public boolean selectrect(int xx0,int yy0,int xx1,int yy1)
    {
	if(xx0<xmin && xx1>xmax && yy0<ymin && yy1>ymax)
	    {
		select = 1;
		return(true);
	    }
	return(false);
    }

    public void addpoint(int xx,int yy)
    {
	xg[n] = xx;
	yg[n] = yy;
	select = n+2;
	if(n<4)n++;
	else select=0;
	setminmax();
    }


    public boolean done()
    {
      if(xg[n-1]==xg[n-2] && yg[n-1]==yg[n-2])
	{
	  n--;
		return(true);
	}
      return(false);
    }

    public void girar() 
    {
	double xp, yp, s, c;
	alfa_old=alfa;
	xc=xxc/n;
	yc=yyc/n;;
	alfa=Math.atan2((yd[n]-yc),(xd[n]-xc));
	s=Math.sin(alfa-alfa_old); c=Math.cos(alfa-alfa_old);
	for(int i=0; i<n; i++){
	xp=(xd[i]-xc)*c-(yd[i]-yc)*s+xc;
	yp=(xd[i]-xc)*s+(yd[i]-yc)*c+yc;
	xd[i]=xp;yd[i]=yp;
	}
    }

    public void ampliar() 
    {
	double xp, yp;
	longit_old=longit;
	xc=xxc/n;
	yc=yyc/n;
	if(Math.sqrt((xd[n+1]-xc)*(xd[n+1]-xc)+(yd[n+1]-yc)*(yd[n+1]-yc))<5)return;
	longit=(Math.sqrt((xd[n+1]-xc)*(xd[n+1]-xc)+(yd[n+1]-yc)*(yd[n+1]-yc)))/(40*Drawing.u);
	for(int i=0; i<n; i++){
	xd[i]=(xd[i]-xc)*(longit/longit_old)+xc;
	yd[i]=(yd[i]-yc)*(longit/longit_old)+yc;
	}
    }


}
