import java.io.*;
import java.awt.*;

//***********************************************************************

class Objetos_punto extends Objetos

//***********************************************************************
{
    static final long serialVersionUID = 369200765359591521L;
    Color c;
    int x0,y0,x1,y1,ikk=0, num=0, nn=0;
    static double tt;
    double X1,X2,Y1,Y2,R1,R2,a1,b1,c1,d1,e1;
    Objetos_mpcircle miCir;
    Objetos_linea miLinea1, miLinea2;
    Objetos_oval miOval, miFoc;
    Objetos_bezicirc miBezicirc;
    Objetos_mpcircle miCir1, miCir2;
    Objetos_rect r1;
    Objetos_round r2;

/* CONSTRUCTORES */

/* Constructor generico para dibujar un punto a mano */
    Objetos_punto(int x,int y, Objetos_list p)
	{
	    super(p);
	    nombre="pu";
	    xd[0] = xd[1] = (double)x;
	    yd[0] = yd[1] = (double)y;
	    x0 = xmin = xmax = x;
	    y0 = ymin = ymax = y;
	    select=0;
	}

/* Constructor para crear un punto resultante de una operacion matematica 
   con doble precision*/
    Objetos_punto(double x, double y, Objetos_list p)
	{
	    super(p);
	    nombre="pu";
	    xd[0] = x; yd[0] = y;
	    select=0;
	}

/* Constructor para crear el punto medio de un segmento si el valor pasado 
por "h" es igual a 1, o los puntos extremos de un segmento si el valor
de h es igual a 2. */ 
    Objetos_punto(Objetos_linea l1, int h, int n, Objetos_list p)
	{
	    super(p);
	    nombre="pu";
	    num=h;
	    nn=n;
	    miLinea1 = l1;
	    select = 5;
	}

/* Constructor para crear el punto de interseccion de dos lineas*/
    Objetos_punto(Objetos_linea l1, Objetos_linea l2, int h, Objetos_list p)
	{
	    super(p);
	    nombre="pu";
	    num=h;
	    miLinea1 = l1;
	    miLinea2 = l2;
	    select = 5;
	}

/* Constructor para crear el punto centro de un circulo */
    Objetos_punto(Objetos_mpcircle cir, int h, Objetos_list p)
	{
	    super(p);
	    nombre="pu";
	    num=h;
	    miCir = cir;
	    select = 5;
	}

/* Constructor para crear el punto centro de una elipse */
    Objetos_punto(Objetos_oval ovv, Objetos_list p)
	{
	    super(p);
	    nombre="pu";
	    num=12;
	    miOval = ovv;
	    select = 5;
	}

/* Constructor para crear los puntos de corte de una recta y un circulo */
    Objetos_punto(Objetos_mpcircle cir, Objetos_linea l1, int h, int n, Objetos_list p)
	{
	    super(p);
	    nombre="pu";
	    num=h;
	    nn=n;
	    miCir = cir;
	    miLinea1 = l1;
	    select = 5;
	}

/* Constructor para crear los puntos de corte de una recta y una elipse. */
    Objetos_punto(Objetos_oval o1, Objetos_linea l1, int h, int n, Objetos_list p)
	{
	    super(p);
	    nombre="pu";
	    num=h;
	    nn=n;
	    miLinea1 = l1;
	    miOval = o1;
	    select=0;
	    init6();
	}

/* Constructor para crear los puntos de corte de una recta y una elipse-circulo. */
    Objetos_punto(Objetos_bezicirc bez, Objetos_linea l1, int h, int n, Objetos_list p)
	{
	    super(p);
	    nombre="pu";
	    nn=n;
	    num=h;
	    miLinea1 = l1;
	    miBezicirc = bez;
	    init9();
	    select=1;
	}


/* Constructor para crear los focos de una elipse. */
    Objetos_punto(Objetos_oval o1, int ii, Objetos_list p)
	{
	    super(p);
	    nombre="pu";
	    num=7;
	    nn=ii;
	    miFoc = o1; 
	    select=0;
	}

/* Constructor para crear los puntos de corte de dos circulos. */
    Objetos_punto(Objetos_mpcircle o1, Objetos_mpcircle o2, int ii, Objetos_list p)
	{
	    super(p);
	    nombre="pu";
	    num=8;
	    nn=ii;
	    miCir1 = o1;
	    miCir2 = o2;
	    select=0;
	}

/* Constructor para crear los 8 puntos de esquinas y medianas de un rectangulo. */
    Objetos_punto(Objetos_rect mir1, int ii, Objetos_list p)
	{
	    super(p);
	    nombre="pu";
	    r1=mir1;
	    nn=ii;
	    num=10;
	    select=0;
	}

/* Constructor para crear los 8 puntos de esquinas y medianas de un round_rect. */
    Objetos_punto(Objetos_round mir2, int ii, Objetos_list p)
	{
	    super(p);
	    nombre="pu";
	    r2=mir2;
	    nn=ii;
	    num=11;
	    select=0;
	}

    public void paint(Graphics g) 
	{
	    Graphics2D g2 = (Graphics2D) g ;
	    CSD = false;

	    if(num==1) //Punto medio de un segmento
	    {
		xd[0]=(miLinea1.xd[0]+miLinea1.xd[1])/2.;
		yd[0]=(miLinea1.yd[0]+miLinea1.yd[1])/2.;
	    }

	    if(num==2) //Puntos extremos de un segmento
	    {
		if(nn==1)
		{
		    xd[0]=miLinea1.xd[0];
		    yd[0]=miLinea1.yd[0];
		}
		else if(nn==2)
		{
		    xd[0]=miLinea1.xd[1];
		    yd[0]=miLinea1.yd[1];
		}
	    }

	    if(num==3) //Punto interseccion de dos rectas
	    {
		xd[1]=miLinea1.xd[0];xd[2]=miLinea1.xd[1];
		xd[3]=miLinea2.xd[0];xd[4]=miLinea2.xd[1];
		yd[1]=miLinea1.yd[0];yd[2]=miLinea1.yd[1];
		yd[3]=miLinea2.yd[0];yd[4]=miLinea2.yd[1];
		intersec(xd, yd);
	    }

	    if(num==4) //Punto centro de un circulo
	    {
		xd[0]=miCir.xd[0];yd[0]=miCir.yd[0];
	    }

	    if(num==5) //Puntos de corte de recta y circulo
	    {
		xd[3]=miLinea1.xd[0]; yd[3]=miLinea1.yd[0];
		xd[4]=miLinea1.xd[1]; yd[4]=miLinea1.yd[1];
		xd[2]=miCir.xd[0];yd[2]=miCir.yd[0];
		double rad = miCir.R1;
		double m = (yd[4]-yd[3])/(xd[4]-xd[3]);
		double h0=yd[3]-m*xd[3];
		double ado = h0-yd[2];
		double bdo = (2.*xd[2]-2.*m*ado)/(1.+m*m);
		double cdo = (xd[2]*xd[2]+ado*ado-rad*rad)/(1+m*m);
		double ddo = Math.sqrt(bdo*bdo-4.*cdo);
		if(nn==1)xd[0] = (bdo+ddo)/2.; 
		if(nn==2)xd[0] = (bdo-ddo)/2.;
		yd[0]=m*xd[0]+h0;
	    }

	if(num==6) {
	double a,b,m,h,ca,d,bb,cc,dd;
	double xdd[] = new double[4];double ydd[] = new double[4];
	double x[] = new double[2]; double y[] = new double[2];
	double alfa=0, xp, yp, c, s, xcentro, ycentro;
	xdd[0]=miOval.xd[0];xdd[1]=miOval.xd[1];
	xdd[2]=miOval.xd[2];xdd[3]=miOval.xd[3];
	ydd[0]=miOval.yd[0];ydd[1]=miOval.yd[1];
	ydd[2]=miOval.yd[2];ydd[3]=miOval.yd[3];
	x[0]=miLinea1.xd[0];x[1]=miLinea1.xd[1];
	y[0]=miLinea1.yd[0];y[1]=miLinea1.yd[1];
	xcentro=(xdd[0]+xdd[1]+xdd[2]+xdd[3])/4; 
	ycentro=(ydd[0]+ydd[1]+ydd[2]+ydd[3])/4;
	alfa=Math.atan((ydd[3]-ydd[0])/(xdd[3]-xdd[0]));
	s=Math.sin(alfa); c=Math.cos(alfa);
	for(int i=0; i<2; i++){
	xp=(xdd[i]-xcentro)*c+(ydd[i]-ycentro)*s+xcentro;
	yp=-(xdd[i]-xcentro)*s+(ydd[i]-ycentro)*c+ycentro;
	xdd[i]=xp;ydd[i]=yp;
	}
	for(int i=0; i<2; i++){
	xp=(x[i]-xcentro)*c+(y[i]-ycentro)*s+xcentro;
	yp=-(x[i]-xcentro)*s+(y[i]-ycentro)*c+ycentro;
	x[i]=xp;y[i]=yp;
	}
	a = (xdd[1]-xdd[0])*(xdd[1]-xdd[0])/4.;
	b = (ydd[1]-ydd[0])*(ydd[1]-ydd[0])/4.;
	if(x[1]!=x[0]){
	    m = (y[1]-y[0])/(x[1]-x[0]);
	    h = y[0]-m*x[0];
	    ca = h-ycentro;
	    d = b+a*m*m;
	    bb = (2.*a*m*ca-2.*b*xcentro)/d;
	    cc = (b*xcentro*xcentro+a*ca*ca-a*b)/d;
	    dd = Math.sqrt(bb*bb-4.*cc);
	    if((m<=0 && nn==1) || (m>0 && nn==2))xd[0] = (-bb-dd)/2.;
	    if((m>0 && nn==1) || (m<=0 && nn==2))xd[0] = (-bb+dd)/2.;
	    yd[0] = m*xd[0]+h;
	}
	else if (x[1]==x[0]){
	    xd[0]=x[0];
	    if(nn==1)yd[0]=ycentro+Math.sqrt(b*(1-(xd[0]-xcentro)*(xd[0]-xcentro)/a));
	    else if(nn==2)yd[0]=ycentro-Math.sqrt(b*(1-(xd[0]-xcentro)*(xd[0]-xcentro)/a));
	}
	xp=(xd[0]-xcentro)*c-(yd[0]-ycentro)*s+xcentro;
	yp=(xd[0]-xcentro)*s+(yd[0]-ycentro)*c+ycentro;
	xd[0]=xp;yd[0]=yp;
    }

	    if(num==7) //Focos de una elipse
	    {
		if(nn==1){
		    xd[0]=miFoc.xf1;yd[0]=miFoc.yf1;}
		else if(nn==2){
		    xd[0]=miFoc.xf2;yd[0]=miFoc.yf2;}
	    }

	    if(num==8) //Corte de dos circulos
	    {
		X1=miCir1.xd[0];Y1=miCir1.yd[0];
		X2=miCir2.xd[0];Y2=miCir2.yd[0];
		R1=miCir1.R1; R2=miCir2.R1;
		a1=(X1-X2)/(Y2-Y1);
		b1=(R1*R1-R2*R2+Y2*Y2-Y1*Y1+X2*X2-X1*X1)/(2.*Y2-2.*Y1);
		e1=b1-Y1;
		c1=(2.*a1*e1-2.*X1)/(a1*a1+1);
		d1=(X1*X1+e1*e1-R1*R1)/(a1*a1+1);
		if(nn==1){xd[0]=(-c1+Math.sqrt(c1*c1-4.*d1))/2.;
		yd[0]=a1*xd[0]+b1;}
		else if(nn==2){xd[0]=(-c1-Math.sqrt(c1*c1-4.*d1))/2.;
		yd[0]=a1*xd[0]+b1;}
	    }	    

	   if(num==9) //Puntos de corte de recta y elipse-circulo
	    {
		double a,b,m,h,xc,yc,c,d,bb,cc,dd;
		a = ((double)miBezicirc.w/2.)*((double)miBezicirc.w/2.);
		b = ((double)miBezicirc.w/2.)*((double)miBezicirc.w/2.);
		xc = (miBezicirc.xd[1]+miBezicirc.xd[0])/2.;
		yc = (miBezicirc.yd[1]+miBezicirc.yd[0])/2.;
		if(miLinea1.xd[1]!=miLinea1.xd[0]){
		    m = (miLinea1.yd[1]-miLinea1.yd[0])/(miLinea1.xd[1]-miLinea1.xd[0]);
		    h = miLinea1.yd[0]-m*miLinea1.xd[0];
		    c = h-yc;
		    d = b+a*m*m;
		    bb = (2.*a*m*c-2.*b*xc)/d;
		    cc = (b*xc*xc+a*c*c-a*b)/d;
		    dd = Math.sqrt(bb*bb-4.*cc);
		    if((m<=0 && nn==1) || (m>0 && nn==2))xd[0] = (-bb-dd)/2.;
		    if((m>0 && nn==1) || (m<=0 && nn==2))xd[0] = (-bb+dd)/2.;
		    yd[0] = m*xd[0]+h;
		}
		else if (miLinea1.xd[1]==miLinea1.xd[0]){
		    xd[0]=miLinea1.xd[0];
		    if(nn==1)yd[0]=yc+Math.sqrt(b*(1-(xd[0]-xc)*(xd[0]-xc)/a));
		    else if(nn==2)yd[0]=yc-Math.sqrt(b*(1-(xd[0]-xc)*(xd[0]-xc)/a));
		}
	    }

	    if(num==10) //Puntos en el centro de los lados de un rect.
		{
		    if(nn==1){xd[0]=r1.xd[0];yd[0]=r1.yd[0];}
		    if(nn==2){xd[0]=r1.xd[1];yd[0]=r1.yd[0];}
		    if(nn==3){xd[0]=r1.xd[1];yd[0]=r1.yd[1];}
		    if(nn==4){xd[0]=r1.xd[0];yd[0]=r1.yd[1];}
		    if(nn==5){xd[0]=(r1.xd[0]+r1.xd[3])/2;yd[0]=(r1.yd[0]+r1.yd[3])/2;}
		    if(nn==6){xd[0]=(r1.xd[3]+r1.xd[1])/2;yd[0]=(r1.yd[3]+r1.yd[1])/2;}
		    if(nn==7){xd[0]=(r1.xd[2]+r1.xd[1])/2;yd[0]=(r1.yd[2]+r1.yd[1])/2;}
		    if(nn==8){xd[0]=(r1.xd[0]+r1.xd[2])/2;yd[0]=(r1.yd[0]+r1.yd[2])/2;}
		}	
		
	    if(num==11) //Puntos en el centro de los lados de un round_rect.
		{
		    if(nn==1){xd[0]=r2.xd[0];yd[0]=r2.yd[0];}
		    if(nn==2){xd[0]=r2.xd[1];yd[0]=r2.yd[0];}
		    if(nn==3){xd[0]=r2.xd[1];yd[0]=r2.yd[1];}
		    if(nn==4){xd[0]=r2.xd[0];yd[0]=r2.yd[1];}
		    if(nn==5){xd[0]=(r2.xd[0]+r2.xd[3])/2;yd[0]=(r2.yd[0]+r2.yd[3])/2;}
		    if(nn==6){xd[0]=(r2.xd[3]+r2.xd[1])/2;yd[0]=(r2.yd[3]+r2.yd[1])/2;}
		    if(nn==7){xd[0]=(r2.xd[2]+r2.xd[1])/2;yd[0]=(r2.yd[2]+r2.yd[1])/2;}
		    if(nn==8){xd[0]=(r2.xd[0]+r2.xd[2])/2;yd[0]=(r2.yd[0]+r2.yd[2])/2;}
		}

	    if(num==12) //Punto centro de una elipse
	    {
		xd[0]=(miOval.xd[0]+miOval.xd[1]+miOval.xd[2]+miOval.xd[3])/4.;
		yd[0]=(miOval.yd[0]+miOval.yd[1]+miOval.yd[2]+miOval.yd[3])/4.;
	    }


	    x0=(int)xd[0];
	    y0=(int)yd[0];
	    xc = xd[0];
	    yc = yd[0];
	    zc = zd[0];
	    int x = x0;
	    int y = y0;
	    int w = 3;
	    int h = 3;

	    float rc = (float) cl.getRed()/255f;
	    float vc = (float) cl.getGreen()/255f;
	    float ac = (float) cl.getBlue()/255f;

	    float strokeThickness = thickness;
	    BasicStroke stroke = new BasicStroke(strokeThickness);
	    g2.setStroke(stroke);
	    g2.setColor(cl);
	 
	    if(select!=0)
	    {
		g2.setColor(Color.red);
		g2.fillRect(x0-1,y0-1,3,3);
		g.drawOval((x0-4),(y0-4), 2*4, 2*4);
	    }
	    else 
	    {
		g2.setColor(cl);
		g2.fillRect(x0-1,y0-1,3,3);
	    }
	    stroke = new BasicStroke(0.5f);
	    g2.setStroke(stroke);
	    g2.setColor(cl);
	}

    public void metapost(BufferedWriter out) 
	{
	    float sy0 = (float)(118*Drawing.u-yd[0]/(10*uesc));
	    float xm0 = (float)(xd[0]/(10*uesc));
	    float th = thickness;
	    float cr=0f, cv=0f, ca=0f;
	    if(c!=null)
	    {
		cr = (float) c.getRed()/255f;
		cv = (float) c.getGreen()/255f;
		ca = (float) c.getBlue()/255f;
	    }
	    float rc = (float) cl.getRed()/255f;
	    float vc = (float) cl.getGreen()/255f;
	    float ac = (float) cl.getBlue()/255f;
	    try 
	    {
		if((int)(10f*rc)!=0 || (int)(10f*vc)!=0 || (int)(10f*ac)!=0)
		{
		    out.write ("loc:= ("+rc+","+vc+","+ac+");\n");
		    out.write ("pickup pencircle scaled "+th+";\ndraw("+xm0+"u,"+sy0+"u) withcolor loc;\n");
		}       	
		else out.write ("pickup pencircle scaled "+th+";\ndraw("+xm0+"u,"+sy0+"u);\n");
	    }
	    catch (IOException ex) { }
	}

    public void moveobj(int x,int y)
	{
	    x0 += x; xd[0] += (double)x;
	    y0 += y; yd[0] += (double)y;
	    xmin=x0-5; ymin=y0-5;
	    xmax=x0+5; ymax=y0+5;
	}

    public void movepoint(int x,int y)
	{
	    x0 += x; xd[0] += (double)x;
	    y0 += y; yd[0] += (double)y;
	    xmin=x0-5; ymin=y0-5;
	    xmax=x0+5; ymax=y0+5;
	}

    public boolean selectpoint(int x,int y)
	{
	    if(((x+5*Drawing.u)>x0 && (x-5*Drawing.u)<x0) && ((y+5*Drawing.u)>y0 && (y-5*Drawing.u)<y0)) 
	    {
		select = 2;
		return(true);
	    }  
	    return(false);
	}

    public boolean selectobj(int x,int y)
	{
	    if(((x+5*Drawing.u)>x0 && (x-5*Drawing.u)<x0) && ((y+5*Drawing.u)>y0 && (y-5*Drawing.u)<y0))
	    {
		select = 1;
		return(true);
	    }
	    return(false);
	}

    public boolean selectrect(int xx0,int yy0,int xx1,int yy1)
	{
	    if(xx0<x0 && xx1>x0 && yy0<y0 && yy1>y0)
	    {
		select = 1;
		return(true);
	    }
	    return(false);
	}


    public Objetos copy(Objetos_list gl)
	{
	    Objetos_punto g;
	    g = new Objetos_punto(x0,y0,gl);
	    g.movepoint(x1-x0,y1-y0);
	    g.select = 0;
	    return(g);
    	}

    public void transform(double xc, double yc, double zc)
	{
	    int n=1;
	    ikk=1;
	    if(value!=0)
		modi(xc,yc,zc,n);
	}

    public static void intersec(double[] xd, double[] yd)
	{
	    tt=(yd[4]-yd[3])*(xd[3]-xd[1])-(yd[3]-yd[1])*(xd[4]-xd[3]);
	    tt/=((yd[4]-yd[3])*(xd[2]-xd[1])-(yd[2]-yd[1])*(xd[4]-xd[3]));
	    xd[0]=xd[1]+(xd[2]-xd[1])*tt;
	    yd[0]=yd[1]+(yd[2]-yd[1])*tt;
	}

    public void init9()	{
		double a,b,m,h,xc,yc,c,d,bb,cc,dd;
		a = ((double)miBezicirc.w/2.)*((double)miBezicirc.w/2.);
		b = ((double)miBezicirc.w/2.)*((double)miBezicirc.w/2.);
		xc = (miBezicirc.xd[1]+miBezicirc.xd[0])/2.;
		yc = (miBezicirc.yd[1]+miBezicirc.yd[0])/2.;
		if(miLinea1.xd[1]!=miLinea1.xd[0]){
		    m = (miLinea1.yd[1]-miLinea1.yd[0])/(miLinea1.xd[1]-miLinea1.xd[0]);
		    h = miLinea1.yd[0]-m*miLinea1.xd[0];
		    c = h-yc;
		    d = b+a*m*m;
		    bb = (2.*a*m*c-2.*b*xc)/d;
		    cc = (b*xc*xc+a*c*c-a*b)/d;
		    dd = Math.sqrt(bb*bb-4.*cc);
		    if((m<=0 && nn==1) || (m>0 && nn==2))xd[0] = (-bb-dd)/2.;
		    if((m>0 && nn==1) || (m<=0 && nn==2))xd[0] = (-bb+dd)/2.;
		    yd[0] = m*xd[0]+h;
		}
		else if (miLinea1.xd[1]==miLinea1.xd[0]){
		    xd[0]=miLinea1.xd[0];
		    if(nn==1)yd[0]=yc+Math.sqrt(b*(1-(xd[0]-xc)*(xd[0]-xc)/a));
		    else if(nn==2)yd[0]=yc-Math.sqrt(b*(1-(xd[0]-xc)*(xd[0]-xc)/a));
		}
	    }

        public void init6()  {
	double a,b,m,h,ca,d,bb,cc,dd;
	double xdd[] = new double[4];double ydd[] = new double[4];
	double x[] = new double[2]; double y[] = new double[2];
	double alfa=0, xp, yp, c, s, xcentro, ycentro;
	xdd[0]=miOval.xd[0];xdd[1]=miOval.xd[1];
	xdd[2]=miOval.xd[2];xdd[3]=miOval.xd[3];
	ydd[0]=miOval.yd[0];ydd[1]=miOval.yd[1];
	ydd[2]=miOval.yd[2];ydd[3]=miOval.yd[3];
	x[0]=miLinea1.xd[0];x[1]=miLinea1.xd[1];
	y[0]=miLinea1.yd[0];y[1]=miLinea1.yd[1];
	xcentro=(xdd[0]+xdd[1]+xdd[2]+xdd[3])/4; 
	ycentro=(ydd[0]+ydd[1]+ydd[2]+ydd[3])/4;
	alfa=Math.atan((ydd[3]-ydd[0])/(xdd[3]-xdd[0]));
	s=Math.sin(alfa); c=Math.cos(alfa);
	for(int i=0; i<2; i++){
	xp=(xdd[i]-xcentro)*c+(ydd[i]-ycentro)*s+xcentro;
	yp=-(xdd[i]-xcentro)*s+(ydd[i]-ycentro)*c+ycentro;
	xdd[i]=xp;ydd[i]=yp;
	}
	for(int i=0; i<2; i++){
	xp=(x[i]-xcentro)*c+(y[i]-ycentro)*s+xcentro;
	yp=-(x[i]-xcentro)*s+(y[i]-ycentro)*c+ycentro;
	x[i]=xp;y[i]=yp;
	}
	a = (xdd[1]-xdd[0])*(xdd[1]-xdd[0])/4.;
	b = (ydd[1]-ydd[0])*(ydd[1]-ydd[0])/4.;
	if(x[1]!=x[0]){
	    m = (y[1]-y[0])/(x[1]-x[0]);
	    h = y[0]-m*x[0];
	    ca = h-ycentro;
	    d = b+a*m*m;
	    bb = (2.*a*m*ca-2.*b*xcentro)/d;
	    cc = (b*xcentro*xcentro+a*ca*ca-a*b)/d;
	    dd = Math.sqrt(bb*bb-4.*cc);
	    if((m<=0 && nn==1) || (m>0 && nn==2))xd[0] = (-bb-dd)/2.;
	    if((m>0 && nn==1) || (m<=0 && nn==2))xd[0] = (-bb+dd)/2.;
	    yd[0] = m*xd[0]+h;
	}
	else if (x[1]==x[0]){
	    xd[0]=x[0];
	    if(nn==1)yd[0]=ycentro+Math.sqrt(b*(1-(xd[0]-xcentro)*(xd[0]-xcentro)/a));
	    else if(nn==2)yd[0]=ycentro-Math.sqrt(b*(1-(xd[0]-xcentro)*(xd[0]-xcentro)/a));
	}
	xp=(xd[0]-xcentro)*c-(yd[0]-ycentro)*s+xcentro;
	yp=(xd[0]-xcentro)*s+(yd[0]-ycentro)*c+ycentro;
	xd[0]=xp;yd[0]=yp;
    }

}



































