/**
    MP-Editor
*/
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import javax.swing.*;

public class mpeditor extends JFrame 
{
    static final long serialVersionUID = 7417153509184740709L;
    protected JTextArea m_monitor;
    
    protected JFileChooser m_chooser;

    Drawing parent;

    public mpeditor(JTextArea itexto)
    {
	super("METAGRAF: MP-Editor");
	    setSize(500,350);
	    
	    m_monitor = itexto;
	    JScrollPane ps = new JScrollPane(m_monitor);
	    getContentPane().add(ps, BorderLayout.CENTER);
	    
	    JMenuBar menuBar = createMenuBar();
	    setJMenuBar(menuBar);
	    
	    m_chooser = new JFileChooser(); 
	    m_chooser.setCurrentDirectory(new File("."));
	    addWindowListener(new BasicWindowMonitor());
    }
    
    protected JMenuBar createMenuBar()
    {
	final JMenuBar menuBar = new JMenuBar();
	    
	    JMenu mFile = new JMenu("File");
	    
	    Action actionNew = new AbstractAction("Clear") 
		{ 
		public void actionPerformed(ActionEvent e)
		{
			m_monitor.setText("");
		    }
		};
	    JMenuItem item =  mFile.add(actionNew); 
	    menuBar.add(item);
	    
	    Action actionOpen = new AbstractAction("Open")
	    { 
		public void actionPerformed(ActionEvent e)
		{
		    m_chooser.rescanCurrentDirectory();
			mpeditor.this.repaint();
			    if (m_chooser.showOpenDialog(mpeditor.this) != 
				JFileChooser.APPROVE_OPTION)
				return;
			    Thread runner = new Thread() {
				    public void run() {
				  File fChoosen = m_chooser.getSelectedFile();
				  try
				      {
					  FileReader in = new FileReader(fChoosen);
					  m_monitor.read(in, null);
					  in.close();
				      } 
				  catch (IOException ex) 
				      {
					  ex.printStackTrace();
				      }
				    }
				};
			    runner.start();
		}
		};
	    item =  mFile.add(actionOpen); 
	    menuBar.add(item);

		Action actionSave = new AbstractAction("Save") 
		{ 
			public void actionPerformed(ActionEvent e)
			{
                                mpeditor.this.repaint();
				if (m_chooser.showSaveDialog(mpeditor.this) != 
					JFileChooser.APPROVE_OPTION)
					return;
                                Thread runner = new Thread() {
                                  public void run() {
			 	    File fChoosen = m_chooser.getSelectedFile();
				    try
				    {
					FileWriter out = new 
						FileWriter(fChoosen);
					m_monitor.write(out);
					out.close();
				    } 
				    catch (IOException ex) 
				    {
					ex.printStackTrace();
				    }
                                  }
                                };
                                runner.start();
			}
		};
                item =  mFile.add(actionSave);
		menuBar.add(item);
		//  menuBar.add(mFile);
    return(menuBar);
    }
}






